=== modified file 'nvdaHelper/remote/gdiHooks.cpp'
--- nvdaHelper/remote/gdiHooks.cpp	2011-06-14 12:21:55 +0000
+++ nvdaHelper/remote/gdiHooks.cpp	2011-07-04 08:52:44 +0000
@@ -422,6 +422,16 @@
 		formatInfo.underline=logFont.lfUnderline?true:false;
 		formatInfo.color=GetTextColor(hdc);
 		formatInfo.backgroundColor=GetBkColor(hdc);
+		//Support RTL reading
+		if((fuOptions&ETO_RTLREADING||textAlign&TA_RTLREADING)&&(logFont.lfCharSet==ARABIC_CHARSET||logFont.lfCharSet==HEBREW_CHARSET)) {
+			const size_t newTextLength=newText.length();
+			const size_t newTextLengthHalf=newTextLength/2;
+			for(size_t i=0;i<newTextLengthHalf;++i) {
+				wchar_t ch=newText[i];
+				newText[i]=newText[newTextLength-i-1];
+				newText[newTextLength-i-1]=ch;
+			}
+		}
 		model->insertChunk(textRect,tm.tmAscent,newText,characterEndXArray,formatInfo,(fuOptions&ETO_CLIPPED)?&clearRect:NULL);
 		HWND hwnd=WindowFromDC(hdc);
 		if(hwnd) queueTextChangeNotify(hwnd,textRect);

